Index: mythplugins/mythvideo/mythvideo/videodlg.cpp
===================================================================
--- mythplugins/mythvideo/mythvideo/videodlg.cpp	(revision 20848)
+++ mythplugins/mythvideo/mythvideo/videodlg.cpp	(working copy)
@@ -3167,6 +3748,112 @@
     }
 }
 
+void VideoDialog::OnVideoImageOnlyDone(bool normal_exit,
+        const SearchListResults &results, Metadata *metadata)
+{
+    if (m_busyPopup)
+    {
+        m_busyPopup->Close();
+        m_busyPopup = NULL;
+    }
+
+    (void) normal_exit;
+    VERBOSE(VB_IMPORTANT,
+            QString("GetVideoList returned %1 possible matches")
+            .arg(results.size()));
+
+    if (results.size() == 1)
+    {
+        // Only one search result, fetch data.
+        if (results.begin().value().isEmpty())
+            return;
+        else
+        {
+            metadata->SetInetRef(results.begin().key());
+            metadata->UpdateDatabase();
+            UpdateItem(GetItemCurrent());
+            StartVideoPosterSet(metadata);
+        }
+    }
+    else if (results.size() < 1)
+    {
+        createOkDialog(tr("No matches were found."));
+    }
+    else
+    {
+        SearchResultsDialog *resultsdialog =
+                new SearchResultsDialog(m_popupStack, results);
+
+        if (resultsdialog->Create())
+            m_popupStack->AddScreen(resultsdialog);
+
+        connect(resultsdialog, SIGNAL(haveResult(QString)),
+                SLOT(OnVideoImgSearchListSelection(QString)),
+                Qt::QueuedConnection);
+    }
+}
+
+void VideoDialog::StartVideoSearchByTitleSubtitle(QString title,
+                                            QString subtitle, Metadata *metadata)
+{
+        createBusyDialog(title);
+
+        VideoTitleSubtitleSearch *vtss = new VideoTitleSubtitleSearch(this);
+
+        connect(vtss, SIGNAL(SigSearchResults(bool, QStringList,
+                                Metadata *)),
+                SLOT(OnVideoSearchByTitleSubtitleDone(bool, QStringList,
+                                Metadata *)));
+        vtss->Run(title, subtitle, metadata);
+}
+
+void VideoDialog::OnVideoSearchByTitleSubtitleDone(bool normal_exit,
+        QStringList result, Metadata *metadata)
+{
+    if (m_busyPopup)
+    {
+        m_busyPopup->Close();
+        m_busyPopup = NULL;
+    }
+
+    (void) normal_exit;
+
+    QString SeasEp = result.takeAt(0);
+
+    if (!SeasEp.isEmpty())
+    {
+
+        // Stuff to parse Season and Episode here
+        QString season, episode = NULL;
+
+        QRegExp group("(?:[s])?(\\d{1,3})(?:\\s|-)?(?:[ex])" //Season
+                      "(?:\\s|-)?(\\d{1,3})", // Episode
+                      Qt::CaseInsensitive);
+
+        int pos = group.indexIn(SeasEp);
+        if (pos > -1)
+        {
+        QString groupResult = group.cap(0);
+        season = group.cap(1);
+        episode = group.cap(2);
+        }
+
+        VERBOSE(VB_IMPORTANT,
+            QString("Season and Episode found!  It was: %1")
+            .arg(SeasEp));
+
+        if (!season.isNull() && !episode.isNull())
+        {
+            metadata->SetSeason(season.toInt());
+            metadata->SetEpisode(episode.toInt());
+            StartVideoSearchByTitle(VIDEO_INETREF_DEFAULT, 
+                                metadata->GetTitle(), metadata);
+        }
+    }
+    else
+        createOkDialog(tr("No matches were found."));
+}
+
 void VideoDialog::doVideoScan()
 {
     if (!m_d->m_scanner)
Index: mythplugins/mythvideo/mythvideo/videolist.cpp
===================================================================
--- mythplugins/mythvideo/mythvideo/videolist.cpp	(revision 20848)
+++ mythplugins/mythvideo/mythvideo/videolist.cpp	(working copy)
@@ -826,7 +826,27 @@
     for (meta_dir_node::const_entry_iterator entry = src->entries_begin();
          entry != src->entries_end(); ++entry)
     {
-        AddFileNode(dst, (*entry)->getData()->GetTitle(), (*entry)->getData());
+        if (((*entry)->getData()->GetSeason() > 0) ||
+                 ((*entry)->getData()->GetEpisode() > 0))
+        {
+            QString seas = QString::number((*entry)->getData()->GetSeason());
+            QString ep = QString::number((*entry)->getData()->GetEpisode());
+            QString tit = (*entry)->getData()->GetTitle();
+            QString sub = (*entry)->getData()->GetSubtitle();
+            if (ep.size() < 2)
+                ep.prepend("0");
+            QString TitSeasEpSub = QString("%1 %2x%3 - %4").arg(tit).arg(seas)
+                                                           .arg(ep).arg(sub);
+            AddFileNode(dst, TitSeasEpSub, (*entry)->getData());
+        }
+        else if ((*entry)->getData()->GetSubtitle().isEmpty())
+            AddFileNode(dst, (*entry)->getData()->GetTitle(), (*entry)->getData());
+        else
+        {
+            QString TitleSub = QString("%1 - %2").arg((*entry)->getData()->GetTitle())
+                                                 .arg((*entry)->getData()->GetSubtitle());
+            AddFileNode(dst, TitleSub, (*entry)->getData());
+        }
     }
 }
 
@@ -1267,7 +1287,7 @@
             QString title = qfi.completeBaseName();
             if (m_infer_title)
             {
-                QString tmptitle(Metadata::FilenameToTitle(file_string));
+                QString tmptitle(Metadata::FilenameToMeta(file_string, 1));
                 if (tmptitle.length())
                     title = tmptitle;
             }
Index: mythplugins/mythvideo/mythvideo/videoscan.cpp
===================================================================
--- mythplugins/mythvideo/mythvideo/videoscan.cpp	(revision 20848)
+++ mythplugins/mythvideo/mythvideo/videoscan.cpp	(working copy)
@@ -267,11 +267,14 @@
                                  VIDEO_SCREENSHOT_DEFAULT,
                                  VIDEO_BANNER_DEFAULT,
                                  VIDEO_FANART_DEFAULT,
-                                 Metadata::FilenameToTitle(p->first),
+                                 Metadata::FilenameToMeta(p->first, 1),
+                                 Metadata::FilenameToMeta(p->first, 4),
                                  VIDEO_YEAR_DEFAULT,
                                  VIDEO_INETREF_DEFAULT, VIDEO_DIRECTOR_DEFAULT,
-                                 VIDEO_PLOT_DEFAULT, 0.0, VIDEO_RATING_DEFAULT,
-                                 0, 0, ParentalLevel::plLowest);
+                                 VIDEO_PLOT_DEFAULT, 0.0, VIDEO_RATING_DEFAULT, 0,
+                                 Metadata::FilenameToMeta(p->first, 2).toInt(), 
+                                 Metadata::FilenameToMeta(p->first, 3).toInt(), 
+                                 0, ParentalLevel::plLowest);
 
                 VERBOSE(VB_GENERAL, QString("Adding : %1 : %2")
                         .arg(newFile.GetHost()).arg(newFile.GetFilename()));
Index: mythplugins/mythvideo/mythvideo/videofilter.cpp
===================================================================
--- mythplugins/mythvideo/mythvideo/videofilter.cpp	(revision 20848)
+++ mythplugins/mythvideo/mythvideo/videofilter.cpp	(working copy)
@@ -353,6 +353,38 @@
             ret = lhs_key < rhs_key;
             break;
         }
+        case kOrderBySeasonEp:
+        {
+            if ((lhs.GetSeason() == rhs.GetSeason())
+                && (lhs.GetEpisode() == rhs.GetEpisode())
+                && (lhs.GetSeason() == 0)
+                && (rhs.GetSeason() == 0)
+                && (lhs.GetEpisode() == 0)
+                && (rhs.GetEpisode() == 0))
+            {
+                Metadata::SortKey lhs_key;
+                Metadata::SortKey rhs_key;
+                if (lhs.HasSortKey() && rhs.HasSortKey())
+                {
+                    lhs_key = lhs.GetSortKey();
+                    rhs_key = rhs.GetSortKey();
+                }
+                else
+                {
+                    lhs_key = Metadata::GenerateDefaultSortKey(lhs,
+                                                               sort_ignores_case);
+                    rhs_key = Metadata::GenerateDefaultSortKey(rhs,
+                                                               sort_ignores_case);
+                }
+                ret = lhs_key < rhs_key;
+            }
+            else if (lhs.GetSeason() == rhs.GetSeason()
+                     && lhs.GetTitle() == rhs.GetTitle())
+                ret = lhs.GetEpisode() < rhs.GetEpisode();
+            else
+                ret = lhs.GetSeason() < rhs.GetSeason();
+            break;
+        }
         case kOrderByYearDescending:
         {
             ret = lhs.GetYear() > rhs.GetYear();
@@ -649,6 +681,8 @@
     // Order by
     new MythUIButtonListItem(m_orderbyList, QObject::tr("Title"),
                            VideoFilterSettings::kOrderByTitle);
+    new MythUIButtonListItem(m_orderbyList, QObject::tr("Season/Episode"),
+                           VideoFilterSettings::kOrderBySeasonEp);
     new MythUIButtonListItem(m_orderbyList, QObject::tr("Year"),
                            VideoFilterSettings::kOrderByYearDescending);
     new MythUIButtonListItem(m_orderbyList, QObject::tr("User Rating"),
Index: mythplugins/mythvideo/mythvideo/metadata.h
===================================================================
--- mythplugins/mythvideo/mythvideo/metadata.h	(revision 20848)
+++ mythplugins/mythvideo/mythvideo/metadata.h	(working copy)
@@ -13,6 +13,8 @@
 
 enum { VIDEO_YEAR_DEFAULT = 1895 };
 
+const QString VIDEO_SUBTITLE_DEFAULT = "";
+
 struct SortData;
 
 class Metadata
@@ -44,7 +46,7 @@
 
   public:
     static SortKey GenerateDefaultSortKey(const Metadata &m, bool ignore_case);
-    static QString FilenameToTitle(const QString &file_name);
+    static QString FilenameToMeta(const QString &file_name, int position);
     static QString TrimTitle(const QString &title, bool ignore_case);
 
   public:
@@ -55,6 +57,7 @@
              const QString &banner = QString(),
              const QString &fanart = QString(),
              const QString &title = QString(),
+             const QString &subtitle = QString(),
              int year = VIDEO_YEAR_DEFAULT,
              const QString &inetref = QString(),
              const QString &director = QString(),
@@ -62,6 +65,8 @@
              float userrating = 0.0,
              const QString &rating = QString(),
              int length = 0,
+             int season = 0,
+             int episode = 0, 
              int id = 0,
              ParentalLevel::Level showlevel = ParentalLevel::plLowest,
              int categoryID = 0,
@@ -89,6 +94,9 @@
     const QString &GetTitle() const;
     void SetTitle(const QString& title);
 
+    const QString &GetSubtitle() const;
+    void SetSubtitle(const QString &subtitle);
+
     int GetYear() const;
     void SetYear(int year);
 
@@ -110,6 +118,12 @@
     int GetLength() const;
     void SetLength(int length);
 
+    int GetSeason() const;
+    void SetSeason(int season);
+
+    int GetEpisode() const;
+    void SetEpisode(int episode);
+
     unsigned int GetID() const;
     void SetID(int id);
 
Index: mythplugins/mythvideo/mythvideo/editmetadata.cpp
===================================================================
--- mythplugins/mythvideo/mythvideo/editmetadata.cpp	(revision 20848)
+++ mythplugins/mythvideo/mythvideo/editmetadata.cpp	(working copy)
@@ -12,6 +12,7 @@
 #include <mythtv/libmythui/mythuitextedit.h>
 #include <mythtv/libmythui/mythuibutton.h>
 #include <mythtv/libmythui/mythuicheckbox.h>
+#include <mythtv/libmythui/mythuispinbox.h>
 
 #include "globals.h"
 #include "dbaccess.h"
@@ -22,9 +23,10 @@
 EditMetadataDialog::EditMetadataDialog(MythScreenStack *lparent,
         QString lname, Metadata *source_metadata,
         const MetadataListManager &cache) : MythScreenType(lparent, lname),
-    m_origMetadata(source_metadata), m_titleEdit(0), m_playerEdit(0),
-    m_categoryList(0), m_levelList(0), m_childList(0), m_browseCheck(0),
-    m_coverartButton(0), m_coverartText(0),
+    m_origMetadata(source_metadata), m_titleEdit(0), m_subtitleEdit(0),
+    m_playerEdit(0), m_seasonSpin(0), m_episodeSpin(0),
+    m_categoryList(0), m_levelList(0), m_childList(0), 
+    m_browseCheck(0), m_coverartButton(0), m_coverartText(0),
     m_screenshotButton(0), m_screenshotText(0),
     m_bannerButton(0), m_bannerText(0),
     m_fanartButton(0), m_fanartText(0),
@@ -47,8 +49,12 @@
 
     bool err = false;
     UIUtilE::Assign(this, m_titleEdit, "title_edit", &err);
+    UIUtilE::Assign(this, m_subtitleEdit, "subtitle_edit", &err);
     UIUtilE::Assign(this, m_playerEdit, "player_edit", &err);
 
+    UIUtilE::Assign(this, m_seasonSpin, "season", &err);
+    UIUtilE::Assign(this, m_episodeSpin, "episode", &err);
+
     UIUtilE::Assign(this, m_coverartText, "coverart_text", &err);
     UIUtilE::Assign(this, m_screenshotText, "screenshot_text", &err);
     UIUtilE::Assign(this, m_bannerText, "banner_text", &err);
@@ -79,8 +85,12 @@
         VERBOSE(VB_IMPORTANT, "Failed to build a focuslist.");
 
     connect(m_titleEdit, SIGNAL(valueChanged()), SLOT(SetTitle()));
+    connect(m_subtitleEdit, SIGNAL(valueChanged()), SLOT(SetSubtitle()));
     connect(m_playerEdit, SIGNAL(valueChanged()), SLOT(SetPlayer()));
 
+    connect(m_seasonSpin, SIGNAL(LosingFocus()), SLOT(SetSeason()));
+    connect(m_episodeSpin, SIGNAL(LosingFocus()), SLOT(SetEpisode()));
+
     connect(m_doneButton, SIGNAL(Clicked()), SLOT(SaveAndExit()));
     connect(m_coverartButton, SIGNAL(Clicked()), SLOT(FindCoverArt()));
     connect(m_bannerButton, SIGNAL(Clicked()), SLOT(FindBanner()));
@@ -154,7 +164,13 @@
 void EditMetadataDialog::fillWidgets()
 {
     m_titleEdit->SetText(m_workingMetadata->GetTitle());
+    m_subtitleEdit->SetText(m_workingMetadata->GetSubtitle());
 
+    m_seasonSpin->SetRange(0,100,1);
+    m_seasonSpin->SetValue(m_workingMetadata->GetSeason());
+    m_episodeSpin->SetRange(0,999,1);
+    m_episodeSpin->SetValue(m_workingMetadata->GetEpisode());
+
     MythUIButtonListItem *button =
         new MythUIButtonListItem(m_categoryList, VIDEO_CATEGORY_UNKNOWN);
     const VideoCategory::entry_list &vcl =
@@ -312,11 +328,26 @@
     m_workingMetadata->SetTitle(m_titleEdit->GetText());
 }
 
+void EditMetadataDialog::SetSubtitle()
+{
+    m_workingMetadata->SetSubtitle(m_subtitleEdit->GetText());
+}
+
 void EditMetadataDialog::SetCategory(MythUIButtonListItem *item)
 {
     m_workingMetadata->SetCategoryID(item->GetData().toInt());
 }
 
+void EditMetadataDialog::SetSeason()
+{
+    m_workingMetadata->SetSeason(m_seasonSpin->GetIntValue());
+}
+
+void EditMetadataDialog::SetEpisode()
+{
+    m_workingMetadata->SetEpisode(m_episodeSpin->GetIntValue());
+}
+
 void EditMetadataDialog::SetPlayer()
 {
     m_workingMetadata->SetPlayCommand(m_playerEdit->GetText());
Index: mythplugins/mythvideo/mythvideo/playercommand.cpp
===================================================================
--- mythplugins/mythvideo/mythvideo/playercommand.cpp	(revision 20848)
+++ mythplugins/mythvideo/mythvideo/playercommand.cpp	(working copy)
@@ -75,26 +75,31 @@
 {
   private:
     VideoPlayHandleMedia(const QString &handler, const QString &mrl,
-            const QString &plot, const QString &title,
-            const QString &director, int length, const QString &year) :
+            const QString &plot, const QString &title, const QString &subtitle,
+            const QString &director, int season, int episode,
+            int length, const QString &year) :
         m_handler(handler), m_mrl(mrl), m_plot(plot), m_title(title),
-        m_director(director), m_length(length), m_year(year)
+        m_subtitle(subtitle), m_director(director), m_season(season),
+        m_episode(episode), m_length(length), m_year(year)
     {
     }
 
   public:
     static VideoPlayHandleMedia *Create(const QString &handler,
             const QString &mrl, const QString &plot, const QString &title,
-            const QString &director, int length, const QString &year)
+            const QString &subtitle, const QString &director,
+            int season, int episode, 
+            int length, const QString &year)
     {
-        return new VideoPlayHandleMedia(handler, mrl, plot, title,
-                director, length, year);
+        return new VideoPlayHandleMedia(handler, mrl, plot, title, subtitle,
+                director, season, episode, length, year);
     }
 
     bool Play() const
     {
         return gContext->GetMainWindow()->HandleMedia(m_handler, m_mrl,
-                m_plot, m_title, m_director, m_length, m_year);
+                m_plot, m_title, m_subtitle, m_director, m_season,
+                m_episode, m_length, m_year);
     }
 
     QString GetCommandDisplayName() const
@@ -112,7 +117,10 @@
     QString m_mrl;
     QString m_plot;
     QString m_title;
+    QString m_subtitle;
     QString m_director;
+    int m_season;
+    int m_episode;
     int m_length;
     QString m_year;
 };
@@ -200,8 +208,9 @@
             if (play_command.length())
             {
                 AddPlayer(play_command, filename, item->GetPlot(),
-                        item->GetTitle(), item->GetDirector(),
-                        item->GetLength(),
+                        item->GetTitle(), item->GetSubtitle(),
+                        item->GetDirector(), item->GetSeason(),
+                        item->GetEpisode(), item->GetLength(),
                         QString::number(item->GetYear()));
             }
             else
@@ -237,8 +246,11 @@
             play_command = "Internal";
 
         QString plot;
-        QString title = Metadata::FilenameToTitle(filename);
+        QString title = Metadata::FilenameToMeta(filename, 1);
+        QString subtitle = Metadata::FilenameToMeta(filename, 4);
         QString director;
+        int season = 0;
+        int episode = 0;
         int length = 0;
         QString year = QString::number(VIDEO_YEAR_DEFAULT);
 
@@ -246,12 +258,16 @@
         {
             plot = extraData->GetPlot();
             title = extraData->GetTitle();
+            subtitle = extraData->GetSubtitle();
             director = extraData->GetDirector();
+            season = extraData->GetSeason();
+            episode = extraData->GetEpisode();
             length = extraData->GetLength();
             year = QString::number(extraData->GetYear());
         }
 
-        AddPlayer(play_command, filename, plot, title, director, length, year);
+        AddPlayer(play_command, filename, plot, title, subtitle, director, 
+                                season, episode, length, year);
     }
 
     void ClearPlayerList()
@@ -282,11 +298,13 @@
 
   private:
     void AddPlayer(const QString &player, const QString &filename,
-            const QString &plot, const QString &title, const QString &director,
-            int length, const QString &year)
+            const QString &plot, const QString &title, const QString &subtitle, 
+            const QString &director, int season, int episode, int length, 
+            const QString &year)
     {
         m_player_procs.push_back(VideoPlayHandleMedia::Create(player, filename,
-                        plot, title, director, length, year));
+                        plot, title, subtitle, director, season, episode, 
+                        length, year));
         m_player_procs.push_back(VideoPlayMythSystem::Create(player, filename));
     }
 
Index: mythplugins/mythvideo/mythvideo/videoutils.h
===================================================================
--- mythplugins/mythvideo/mythvideo/videoutils.h	(revision 20848)
+++ mythplugins/mythvideo/mythvideo/videoutils.h	(working copy)
@@ -33,6 +33,7 @@
 
 QString GetDisplayUserRating(float userrating);
 QString GetDisplayLength(int length);
+QString GetDisplaySeasonEpisode(int seasEp, int digits);
 QString GetDisplayBrowse(bool browse);
 QString GetDisplayYear(int year);
 QString GetDisplayRating(const QString &rating);
Index: mythtv/libs/libmythui/mythmainwindow.cpp
===================================================================
--- mythtv/libs/libmythui/mythmainwindow.cpp	(revision 20848)
+++ mythtv/libs/libmythui/mythmainwindow.cpp	(working copy)
@@ -1298,7 +1298,9 @@
 
 bool MythMainWindow::HandleMedia(const QString &handler, const QString &mrl,
                                  const QString &plot, const QString &title,
-                                 const QString &director, int lenMins,
+                                 const QString &subtitle, 
+                                 const QString &director, int season,
+                                 int episode, int lenMins,
                                  const QString &year)
 {
     QString lhandler(handler);
@@ -1308,8 +1310,9 @@
     // Let's see if we have a plugin that matches the handler name...
     if (d->mediaPluginMap.count(lhandler))
     {
-        d->mediaPluginMap[lhandler].playFn(mrl, plot, title,
-                                          director, lenMins, year);
+        d->mediaPluginMap[lhandler].playFn(mrl, plot, title, subtitle,
+                                          director, season, episode, lenMins, 
+                                          year);
         return true;
     }
 
Index: mythtv/libs/libmythui/mythmainwindow.h
===================================================================
--- mythtv/libs/libmythui/mythmainwindow.h	(revision 20848)
+++ mythtv/libs/libmythui/mythmainwindow.h	(working copy)
@@ -17,7 +17,7 @@
 #define REG_JUMPEX(a, b, c, d, e) GetMythMainWindow()->RegisterJump(a, b, c, d, e)
 #define REG_MEDIAPLAYER(a,b,c) GetMythMainWindow()->RegisterMediaPlugin(a, b, c)
 
-typedef int (*MediaPlayCallback)(const QString &, const QString &, const QString &, const QString &, int, const QString &);
+typedef int (*MediaPlayCallback)(const QString &, const QString &, const QString &, const QString &, const QString &, int, int, int, const QString &);
 
 class MythMainWindowPrivate;
 
@@ -63,7 +63,8 @@
 
     bool HandleMedia(const QString& handler, const QString& mrl,
                      const QString& plot="", const QString& title="",
-                     const QString& director="", int lenMins=120,
+                     const QString& subtitle="", const QString& director="", 
+                     int season=0, int episode=0, int lenMins=120, 
                      const QString& year="1895");
 
     void JumpTo(const QString &destination, bool pop = true);
Index: mythtv/programs/mythfrontend/main.cpp
===================================================================
--- mythtv/programs/mythfrontend/main.cpp	(revision 20848)
+++ mythtv/programs/mythfrontend/main.cpp	(working copy)
@@ -672,7 +672,8 @@
 }
 
 int internal_play_media(const QString &mrl, const QString &plot,
-                        const QString &title, const QString &director,
+                        const QString &title, const QString &subtitle,
+                        const QString &director, int season, int episode,
                         int lenMins, const QString &year)
 {
     int res = -1;
@@ -711,12 +712,26 @@
         pginfo->pathname = QString("dvd:%1").arg(mrl);
     }
 
-    pginfo->description = plot;
-
     if (director.length())
-        pginfo->subtitle = QString( "%1: %2" )
+        pginfo->description = QString( "%1: %2.  " )
                            .arg(QObject::tr("Directed By")).arg(director);
 
+    pginfo->description += plot;
+
+    if (subtitle.length())
+        pginfo->subtitle = subtitle;
+
+    if ((season > 0) || (episode > 0))
+    {
+        QString seas, ep;
+        seas = QString::number(season);
+        ep = QString::number(episode);
+        if (ep.size() < 2)
+            ep.prepend("0");
+        QString SeasEpTitle =  QString("%1x%2").arg(seas).arg(ep);
+        pginfo->chanstr = SeasEpTitle;
+    }
+
     pginfo->title = title;
 
     if (pginfo->pathname.startsWith("dvd:"))
